"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGTraitTransformation subclass:#RGTraitAlias
	instanceVariableNames:'aliases'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGTraitAlias comment:''
!

!RGTraitAlias methodsFor:'accessing - backend'!

addAlias: aSymbol 

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior addAlias: aSymbol to: self ].
!

aliasesDo: aBlock

    self backend forBehavior aliasesFor: self do: aBlock
!

cleanAliases

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior cleanAliasesFor: self ].
!

removeAlias: aSymbol

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior removeAlias: aSymbol from: self ].
! !

!RGTraitAlias methodsFor:'as yet unclassified'!

traitCompositionString

    ^ String streamContents: [:aStream |	
        aStream 
            nextPutAll: self subject traitTransformationString;
            space;
            nextPut: $@;
            space;
            nextPut: ${.
    self aliases do: [:each | aStream print: each]
        separatedBy: [aStream nextPutAll: '. '].
    aStream nextPut: $}].
!

traitTransformationString

    ^ String streamContents: [:aStream |	
        aStream 
            nextPut: $(;
            nextPutAll: self subject name;
            space;
            nextPut: $@;
            space;
            nextPut: ${.
    self aliases do: [:each | aStream print: each]
        separatedBy: [aStream nextPutAll: '. '].
    aStream nextPut: $}.
    aStream nextPut: $)].
! !

!RGTraitAlias methodsFor:'default model values'!

defaultAliases

    ^ OrderedCollection new
! !

!RGTraitAlias methodsFor:'initialize'!

initialize

    super initialize.
    
    aliases := self unresolvedValue: self defaultAliases.
!

initializeUnresolved

    super initializeUnresolved.
    
    aliases := self unresolvedValue: self defaultAliases.
! !

!RGTraitAlias methodsFor:'private - backend access'!

pvtAddAlias: aSymbol

    aliases isRingResolved ifFalse: [ 
        self pvtCleanAliases  ].
    
    aliases add: aSymbol.	
!

pvtAliasesDo: aBlock

    aliases value do: aBlock
!

pvtCleanAliases

    aliases := self defaultAliases.
!

pvtRemoveAlias: aSymbol

    aliases remove: aSymbol.
!

pvtResolvableProperties

    ^ super pvtResolvableProperties, { 
        #aliases -> aliases. 
    }
    
    
! !

!RGTraitAlias methodsFor:'queries - aliases'!

aliases

    | allAliases |
    allAliases := OrderedCollection new.
    self aliasesDo: [ :each | allAliases add: each].
    ^ allAliases 
! !

!RGTraitAlias methodsFor:'queries - methods'!

methods

    "TODO"
    ^ self subject methods reject: [ :each | self aliases includes: each name  ]
! !

!RGTraitAlias methodsFor:'resolving'!

makeResolved

    super makeResolved.
    
    aliases := self aliases markAsRingResolved.
! !

!RGTraitAlias methodsFor:'testing types'!

isTraitAlias

    ^ true
! !

