"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGTraitTransformation subclass:#RGTraitExclusion
	instanceVariableNames:'exclusions'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGTraitExclusion comment:''
!

!RGTraitExclusion methodsFor:'accessing - backend'!

addExclusion: aSymbol 

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior addExclusion: aSymbol to: self. ].
!

cleanExclusions

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior cleanExclusionsFor: self. ].
    
!

exclusionsDo: aBlock

    self backend forBehavior exclusionsFor: self do: aBlock
!

removeExclusion: aSymbol

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior removeExclusion: aSymbol from: self. ].
! !

!RGTraitExclusion methodsFor:'as yet unclassified'!

traitTransformationString

    ^ String streamContents: [:aStream |	
        aStream 
            nextPut: $(;
            nextPutAll: self subject name;
            space;
            nextPut: $-;
            space;
            nextPut: ${.
    self exclusions do: [:each | aStream print: each]
        separatedBy: [aStream nextPutAll: '. '].
    aStream nextPut: $}.
    aStream nextPut: $).].
! !

!RGTraitExclusion methodsFor:'default model values'!

defaultExclusions

    ^ OrderedCollection new
! !

!RGTraitExclusion methodsFor:'initialization'!

initialize

    super initialize.
    
    exclusions := self unresolvedValue: self defaultExclusions.
!

initializeUnresolved

    super initializeUnresolved.
    
    exclusions := self unresolvedValue: self defaultExclusions.
! !

!RGTraitExclusion methodsFor:'private - backend access'!

pvtAddExclusion: aSymbol


    exclusions isRingResolved ifFalse: [ 
        self pvtCleanExclusions  ].
    
    exclusions add: aSymbol.	
!

pvtCleanExclusions

    exclusions := self defaultExclusions.
!

pvtExclusionsDo: aBlock

    exclusions value do: aBlock
!

pvtRemoveExclusion: aSymbol

    exclusions remove: aSymbol.
!

pvtResolvableProperties

    ^ super pvtResolvableProperties, { 
        #exclusions -> exclusions. 
    }
    
    
! !

!RGTraitExclusion methodsFor:'queries - exclusions'!

exclusions

    | allExclusions |
    allExclusions := OrderedCollection new.
    self exclusionsDo: [ :each | allExclusions add: each].
    ^ allExclusions
! !

!RGTraitExclusion methodsFor:'queries - methods'!

methods

    ^ self subject methods reject: [ :each | self exclusions includes: each name  ]
! !

!RGTraitExclusion methodsFor:'resolving'!

makeResolved

    super makeResolved.
    
    exclusions := self exclusions markAsRingResolved.
! !

!RGTraitExclusion methodsFor:'testing types'!

isTraitExclusion

    ^ true
! !

!RGTraitExclusion methodsFor:'traits'!

traitCompositionString

    ^ String streamContents: [:aStream |	
        aStream 
            nextPutAll: self subject name traitTransformationString;
            space;
            nextPut: $-;
            space;
            nextPut: ${.
    self exclusions do: [:each | aStream print: each]
        separatedBy: [aStream nextPutAll: '. '].
    aStream nextPut: $}].
! !

