"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGObject subclass:#RGTraitTransformation
	instanceVariableNames:'subject'
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGTraitTransformation comment:''
!

!RGTraitTransformation methodsFor:'accessing - backend'!

name: aString

    self parent parent announceDefinitionChangeDuring: [ 
        super name: aString ].
!

subject

    ^ self backend forBehavior subjectFor: self
!

subject: anRGTrait

    self parent parent announceDefinitionChangeDuring: [ 
        self backend forBehavior setSubjectFor: self to: anRGTrait. ].
!

usedTraits

    ^ IdentitySet with: subject.
! !

!RGTraitTransformation methodsFor:'as yet unclassified'!

trait
    
    ^ self subject trait
! !

!RGTraitTransformation methodsFor:'default model values'!

defaultSubject

    ^ RGUnresolvedValue recursive
! !

!RGTraitTransformation methodsFor:'initialize'!

initialize

    super initialize.
    
    subject := self unresolvedValue: self defaultSubject.
!

initializeUnresolved

    super initializeUnresolved.
    
    subject := self unresolvedValue: self defaultSubject.
! !

!RGTraitTransformation methodsFor:'managing container'!

addoptToParentStub

    super addoptToParentStub.
    self parent addTransformation: self.
!

defaultParentStub

    ^ self defaultTraitCompositionStub
! !

!RGTraitTransformation methodsFor:'private - backend interface'!

pvtResolvableProperties

    ^ super pvtResolvableProperties, { 
        #subject -> subject. 
    }
    
    
!

pvtSubject

    ^ subject value
!

pvtSubject: anRGTrait

    self environment verifyOwnership: anRGTrait.

    ^ subject := anRGTrait
! !

!RGTraitTransformation methodsFor:'queries - methods'!

methods

    self subclassResponsibility 
! !

!RGTraitTransformation methodsFor:'resolving'!

makeResolved

    super makeResolved.
    
    subject := self subject markAsRingResolved.
! !

!RGTraitTransformation methodsFor:'testing types'!

isTraitTransformation

    ^ true
! !

