"{ Package: 'stx:goodies/ring/core/tests' }"

"{ NameSpace: Smalltalk }"

RGTest subclass:#RGTraitStrategyTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Tests-Core'
!

RGTraitStrategyTest comment:''
!

!RGTraitStrategyTest methodsFor:'tests'!

testClassVariablesString

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.

    self assert: anRGBehavior classVariablesString equals: ''

!

testCreationByMethod

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: (anRGBehavior isBehavior).	
    self assert: (anRGBehavior behaviorStrategy isTraitStrategy).
!

testIncompatibleBehavior

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    
    self checkIncompatible: [ 
        anRGBehavior instanceVariables: Array new ].
    self checkIncompatible: [ 
        anRGBehavior kindOfSubclass].
    self checkIncompatible: [ 
        anRGBehavior removeClassVariable: (RGClassVariable named: #ClassVar parent: anRGBehavior)].
    self checkIncompatible: [ 
        anRGBehavior removeSharedPool: (anRGBehavior environment ensureClassNamed: #SomeClass)].
    self checkIncompatible: [ 
        anRGBehavior sharedPoolsDo: [ :sharedPool | ] ].
    self checkIncompatible: [ 
        anRGBehavior defaultMetaClass ].
!

testInstSize

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: anRGBehavior instSize equals: 0
!

testInstanceVariablesString

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: anRGBehavior instanceVariablesString equals: ''
!

testKind

    | strategy |
    
    strategy := RGBehavior newTrait behaviorStrategy.
    self deny: strategy isClassStrategy.
    self deny: strategy isMetaclassStrategy.
    self assert: strategy isTraitStrategy.
    self deny: strategy isMetaclassTraitStrategy.
    
!

testResolvingConsistency

    | anObject |
    anObject := RGTrait unnamed behaviorStrategy.
    self checkClassesConsistency: anObject and: anObject makeResolved
!

testSharedPoolNames

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: (anRGBehavior sharedPoolNames isEmpty).
!

testSharedPools

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: (anRGBehavior sharedPools isEmpty).
!

testTrait

    | anRGBehavior |
    
    anRGBehavior := RGBehavior newTrait.
    self assert: anRGBehavior trait equals: anRGBehavior
! !

