"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/ring/tooling' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#stx_goodies_ring_tooling
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_ring_tooling class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare

"
! !

!stx_goodies_ring_tooling class methodsFor:'description'!

excludedFromPreRequisites
    "obsolete; temporarily, this is still called for, but will eventually vanish.
    
     List packages which are to be explicitely excluded from the automatic constructed
     prerequisites lists (both). 
     If empty, everything that is found along the inheritance of any of
     my classes is considered to be a prerequisite package."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes.
     Please take a look at the #referencedPreRequisites method as well."

    ^ #(
        #'stx:goodies/ring/core'    "RGBehavior - extended"
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_ring_tooling"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     These packages are NOT needed as a prerequisite for compiling or loading,
     however, a class from it may be referenced during execution and having it
     unloaded then may lead to a runtime doesNotUnderstand error, unless the caller
     includes explicit checks for the package being present.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes.
     Please also take a look at the #mandatoryPreRequisites method"

    ^ #(
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine #referencedPrerequisites or #mandatoryPreRequisites."

    ^ #(
    )
! !

!stx_goodies_ring_tooling class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'stx_goodies_ring_tooling'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector.
     A correponding method with real names must be present in my concrete subclasses
     if it has extensions."

    ^ #(
        RGBehavior allSubclasses
        RGBehavior allSubclassesDo:
        RGBehavior allSuperclassesDo:
        RGBehavior basicFileOutDefinitionOn:withNameSpace:withPackage:
        RGBehavior commonSuperclass:
        RGBehavior hasExtensions
        RGBehavior iconInBrowserSymbol
        RGBehavior instAndClassMethodsDo:
        RGBehavior instAndClassSelectorsAndMethodsDo:
        RGBehavior isAbstract
        RGBehavior isLoaded
        RGBehavior isObsolete
        RGBehavior isPrivate
        RGBehavior isStartableWithMain
        RGBehavior isStartableWithStart
        RGBehavior isSubclassOf:
        RGBehavior isUtilityClass
        RGBehavior isVisualStartable
        RGBehavior methodDictionary
        RGBehavior methodsCount
        RGBehavior nameInBrowser
        RGBehavior owningClass
        RGBehavior privateClassesAt:
        RGBehavior programmingLanguage
        RGBehavior revision
        RGBehavior revisionInfo
        RGBehavior selectorsAndMethodsDo:
        RGBehavior soleInstance
        RGBehavior subclassDefinerClass
        RGBehavior supportsMethodCategories
        RGBehavior syntaxHighlighterClass
        RGBehavior theMetaclass
        RGBehavior theNonMetaclass
        RGBehavior topNameSpace
        RGBehavior wasAutoloaded
        RGBehavior whichClassIncludesSelector:
        RGBehavior withAllSuperclasses
        RGBehavior withAllSuperclassesDo:
        RGEnvironment allClasses
        RGEnvironment allClassesDo:
        RGEnvironment hasNameSpaces
        RGMethod breakpointsDo:
        RGMethod byteCode
        RGMethod getMclass
        RGMethod isBreakpointed
        RGMethod isDocumentationMethod
        RGMethod isIgnored
        RGMethod isInstrumented
        RGMethod isObsolete
        RGMethod isPrivate
        RGMethod isProtected
        RGMethod isSynthetic
        RGMethod isVersionMethod
        RGMethod isWrapped
        RGMethod mclass
        RGMethod messagesSentToSelf
        RGMethod messagesSentToSuper
        RGMethod previousVersionCode
        RGMethod printStringForBrowserWithSelector:inClass:
        RGMethod programmingLanguage
        RGMethod resources
        RGMethod sendsAnySelector:
        RGMethod source
        RGMethod syntaxHighlighterClass
        RGMethod wrapper
        RGBehavior commentOrDocumentationString
        RGEnvironment at:
        RGMethod comment
        RGMethod hasAnnotation
        RGMethod superMessages
    )
! !

!stx_goodies_ring_tooling class methodsFor:'description - project information'!

companyName
    "Returns a company string which will appear in <lib>.rc.
     Under win32, this is placed into the dll's file-info.
     Other systems may put it elsewhere, or ignore it."

    ^ 'Claus Gittinger & eXept Software AG'
!

description
    "Returns a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Returns a copyright string which will appear in <lib>.rc.
     Under win32, this is placed into the dll's file-info.
     Other systems may put it elsewhere, or ignore it."

    ^ 'Copyright Claus Gittinger 2020\nCopyright eXept Software AG 2020'
!

productName
    "Returns a product name which will appear in <lib>.rc.
     Under win32, this is placed into the dll's file-info.
     This method is usually redefined in a concrete application definition"

    ^ 'Smalltalk/X'
! !

!stx_goodies_ring_tooling class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

